import java.util.*;

class ShapeCollection {
    private LinkedList linkedList = new LinkedList();

    public void addShape(Shape shape) {
        this.linkedList.add(shape);
    }
    public void clear() {
        this.linkedList.clear();
    }
    public ShapeIterator iterator() {
        return new ShapeIteratorImpl();
    }
    private class ShapeIteratorImpl implements ShapeIterator {
        ListIterator iterator;

        ShapeIteratorImpl() {
            this.iterator = linkedList.listIterator();
        }
        public boolean hasNext() {
            return this.iterator.hasNext();
        }
        public boolean hasPrevious() {
            return this.iterator.hasPrevious();
        }
        public Shape next() {
            return (Shape)this.iterator.next();
        }
        public Shape previous() {
            return (Shape)this.iterator.previous();
        }
    }
}
