class RectangleCommand extends Command {
    private static final int INITIAL_MODE = 0;
    private static final int DRAGGING_START_MODE = 1;
    private static final int DRAGGING_MODE = 2;
    private double startX;
    private double startY;
    private double prevX;
    private double prevY;
    private int currentMode;

    RectangleCommand(ShapeCollection shapeCollection) {
        super(shapeCollection);
        currentMode = INITIAL_MODE;
    }
    public void mouseButtonPressed(DrawWindow d, double x, double y,
                                   int button) {
        this.startX = x;
        this.startY = y;
        this.currentMode = DRAGGING_START_MODE;
    }
    public void mouseButtonReleased(DrawWindow d, double x, double y,
                                    int button) {
        if (this.currentMode != DRAGGING_MODE) {
            this.currentMode = INITIAL_MODE;
            return;
        }
        d.setXORMode(true);
        d.drawRectangle(this.startX, this.startY, this.prevX, this.prevY);
        d.setXORMode(false);
        d.drawRectangle(this.startX, this.startY, x, y);

        shapeCollection.addShape(new Rectangle(this.startX, this.startY,
                                               x, y));
        this.currentMode = INITIAL_MODE;
    }
    public void mouseMoved(DrawWindow d, double x, double y) {
        if (this.currentMode == INITIAL_MODE)
            return;

        d.setXORMode(true);
        if (currentMode == DRAGGING_MODE) {
            d.drawRectangle(this.startX, this.startY,
                            this.prevX, this.prevY);
        } else {
            this.currentMode = DRAGGING_MODE;
        }
        d.drawRectangle(this.startX, this.startY, x, y);

        d.setXORMode(false);

        this.prevX = x;
        this.prevY = y;
    }
}
