class ShapeCollection {
    private class ShapeItem {
        Shape           shape;
        ShapeItem       prev;
        ShapeItem       next;
    }
    ShapeItem   head = null;
    ShapeItem   tail = null;

    public void addShape(Shape shape) {
        ShapeItem newItem = new ShapeItem();
        newItem.shape = shape;
        if (this.tail == null) {
            this.head = this.tail = newItem;
        } else {
            this.tail.next = newItem;
            newItem.prev = this.tail;
            this.tail = newItem;
        }
    }
    public void clear() {
        this.head = this.tail = null;
    }
    public ShapeIterator iterator() {
        return new ShapeIteratorImpl();
    }
    private class ShapeIteratorImpl implements ShapeIterator {
        // Ce[^͗vfƗvf́uԁvwB
        // cursorPrev́Ä݂ʒúuЂƂÓvShapeItemwB
        private ShapeItem       cursorPrev;

        ShapeIteratorImpl() {
            this.cursorPrev = null;
        }
        public boolean hasNext() {
            if (this.cursorPrev == null) {
                return head != null;
            } else {
                return this.cursorPrev.next != null;
            }
        }
        public boolean hasPrevious() {
            return this.cursorPrev != null;
        }
        public Shape next() {
            if (this.cursorPrev == null) {
                this.cursorPrev = head;
                return head.shape;
            } else {
                this.cursorPrev = this.cursorPrev.next;
                return this.cursorPrev.shape;
            }
        }
        public Shape previous() {
            Shape ret = this.cursorPrev.shape;
            this.cursorPrev = this.cursorPrev.prev;
            return ret;
        }
    }
}
